#include <algorithm>
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <utility>
#include <vector>

constexpr auto booklist_path = "booklist.txt"; // Xgt@C̃pX

struct Book {
    std::string    title;      // 
    std::string    author;     // Җ
    int            price;      // i
    int            evaluate;   // ]
};

// W͂ int^̒l󂯎B
// ߂l: ͂ꂽ int^̒lƁA̐ۂi[ std::pairB
std::pair<int, bool> get_int_from_stdin(void);

// {̃f[^Wo͂֏oB
// book: {̃f[^
void print_book_data(const Book& book);

// ua: {o^v
// books: {̃f[^̔z
// ߂l: o^ł trueAs false
bool command_add(std::vector<Book>& books);

// ud: {폜v
// books: {̃f[^̔z
// ߂l: 폜ł trueAs false
bool command_delete(std::vector<Book>& books);

// uc: ׂĂ̖{폜v
// books: {̃f[^̔z
void command_clear(std::vector<Book>& books);

// up: XgmFv
// books: {̃f[^̔z
void command_print(const std::vector<Book>& books);

// ust: Ōv
// books: {̃f[^̔z
void command_search_by_title(const std::vector<Book>& books);

//usa: ҖŌv
// books: {̃f[^̔z
void command_search_by_author(const std::vector<Book>& books);

// usp: iŌv
// books: {̃f[^̔z
void command_search_by_price(const std::vector<Book>& books);

// use: ]Ōv
// books: {̃f[^̔z
void command_search_by_evaluate(const std::vector<Book>& books);

// ur: t@Cǂݍށv
// books: {̃f[^̔z
// ߂l:  trueAs false
bool command_read_file(std::vector<Book>& books);

// uw: t@Cɏށv
// books: {̃f[^̔z
// ߂l:  trueAs false
bool command_write_file(const std::vector<Book>& books);

// ue: Iv
// isChanged: ύX邩ǂ
// ߂l: Iłꍇ trueAIȂꍇ false
bool command_exit(bool isChanged);


int main()
{
    std::vector<Book> books {};
    bool isChanged {false};

    while (true) {
        std::cout << "----------------------------\n"
                  << "R}h͂ĂB\n"
                  << "a: {o^B\n"
                  << "d: {폜B\n"
                  << "c: ׂĂ̖{폜B\n"
                  << "p: XgmFB\n"
                  << "st: ŌB\n"
                  << "sa: ҖŌB\n"
                  << "sp: iŌB\n"
                  << "se: ]ŌB\n"
                  << "r: t@CǂݍށB\n"
                  << "w: t@CɏށB\n"
                  << "e: IB\n"
                  << "----------------------------\n";

        std::string command {};
        std::getline(std::cin, command);
        if (command == "a") {
            if (command_add(books)) {
                isChanged = true;
            }
        }
        else if (command == "d") {
            if (command_delete(books)) {
                isChanged = true;
            }
        }
        else if (command == "c") {
            command_clear(books);
            isChanged = true;
        }
        else if (command == "p") {
            command_print(books);
        }
        else if (command == "st") {
            command_search_by_title(books);
        }
        else if (command == "sa") {
            command_search_by_author(books);
        }
        else if (command == "sp") {
            command_search_by_price(books);
        }
        else if (command == "se") {
            command_search_by_evaluate(books);
        }
        else if (command == "r") {
            if (command_read_file(books)) {
                isChanged = false;
            }
        }
        else if (command == "w") {
            if (command_write_file(books)) {
                isChanged = false;
            }
        }
        else if (command == "e") {
            if (command_exit(isChanged)) {
                return 0;
            }
        }
        else {
            // ȃR}h
            continue;
        }
    }
}

std::pair<int, bool> get_int_from_stdin(void)
{
    std::pair<int, bool> result {};

    std::string tmp {};
    std::getline(std::cin, tmp);
    std::istringstream iss {tmp};
    iss >> result.first;
    if (!iss) {
        result.second = false;
    }
    else {
        result.second = true;
    }

    return result;
}

void print_book_data(const Book& book)
{
    std::cout << ": " << book.title << "\n"
              << "Җ: " << book.author << "\n"
              << "i: " << book.price << "\n"
              << "]: " << book.evaluate << "\n"
              << "\n";
}

bool command_add(std::vector<Book>& books)
{
    Book book {};

    std::cout << "͂ĂB\n";
    std::getline(std::cin, book.title);

    std::cout << "Җ͂ĂB\n";
    std::getline(std::cin, book.author);

    std::cout << "i͂ĂB\n";
    while (true) {
        auto price = get_int_from_stdin();
        if (!price.second || price.first < 0) {
            std::cout << "i 0ȏ̐œ͂ĂB\n";
        }
        else {
            book.price = price.first;
            break;
        }
    }

    std::cout << "]͂ĂB\n";
    auto evaluate = get_int_from_stdin();
    if (!evaluate.second) {
        std::cout << "͓eɕs܂B\n";
        return false;
    }
    else {
        book.evaluate = evaluate.first;
        books.push_back(book);
        std::cout << "o^܂B\n";
        return true;
    }
}

bool command_delete(std::vector<Book>& books)
{
    std::cout << "͂ĂB\n";
    std::string title {};
    std::getline(std::cin, title);

    auto it = std::find_if(std::cbegin(books), std::cend(books), [title](Book e){ return e.title == title; });
    if (it == std::cend(books)) {
        std::cout << "w肳ꂽ{͓o^Ă܂B\n";
        return false;
    }
    else {
        books.erase(it);
        std::cout << "폜܂B\n";
        return true;
    }
}

void command_clear(std::vector<Book>& books)
{
    books.clear();
    std::cout << "폜܂B\n";
}

void command_print(const std::vector<Book>& books)
{
    for (auto& book : books) {
        print_book_data(book);
    }
}

void command_search_by_title(const std::vector<Book>& books)
{
    std::cout << "͂ĂB\n";
    std::string title {};
    std::getline(std::cin, title);

    for (auto& book : books) {
        if (book.title == title) {
            print_book_data(book);
        }
    }
}

void command_search_by_author(const std::vector<Book>& books)
{
    std::cout << "Җ͂ĂB\n";
    std::string author {};
    std::getline(std::cin, author);

    for (auto& book : books) {
        if (book.author == author) {
            print_book_data(book);
        }
    }
}

void command_search_by_price(const std::vector<Book>& books)
{
    std::cout << "i͂ĂB\n";
    auto price = get_int_from_stdin();
    if (!price.second || price.first < 0) {
        std::cout << "͓eɕs܂B\n";
    }
    else {
        for (auto& book : books) {
            if (book.price >= price.first) {
                print_book_data(book);
            }
        }
    }
}

void command_search_by_evaluate(const std::vector<Book>& books)
{
    std::cout << "]͂ĂB\n";
    auto evaluate = get_int_from_stdin();
    if (!evaluate.second) {
        std::cout << "͓eɕs܂B\n";
    }
    else {
        for (auto& book : books) {
            if (book.evaluate >= evaluate.first) {
                print_book_data(book);
            }
        }
    }
}

bool command_read_file(std::vector<Book>& books)
{
    std::ifstream ifs(booklist_path);
    if (!ifs) {
        std::cout << "t@CJ܂B\n";
        return false;
    }

    // ̖{̃f[^
    books.clear();

    while (!ifs.eof()) {
        Book book {};
        std::istringstream iss {};
        std::string tmp {};

        std::getline(ifs, book.title);
        if (book.title.empty()) {
            break;
        }

        std::getline(ifs, book.author);

        std::getline(ifs, tmp);
        iss.str(tmp);
        iss >> book.price;
        iss.clear();

        std::getline(ifs, tmp);
        iss.str(tmp);
        iss >> book.evaluate;

        books.push_back(book);
    }

    std::cout << "ǂݍ݂܂B\n";
    return true;
}

bool command_write_file(const std::vector<Book>& books)
{
    std::ofstream ofs(booklist_path);
    if (!ofs) {
        std::cout << "t@CJ܂B\n";
        return false;
    }

    for (auto& book : books) {
        ofs << book.title << "\n"
            << book.author << "\n"
            << book.price << "\n"
            << book.evaluate << "\n";
    }

    ofs.close();
    if (!ofs) {
        std::cout << "݂Ɏs܂B\n";
        return false;
    }

    std::cout << "݂܂B\n";
    return true;
}

bool command_exit(bool isChanged)
{
    if (isChanged) {
        std::cout << "ύXet@Cɏł܂񂪁AIĂ낵łH (Y/N)\n";
        std::string s {};
        std::cin >> s;
        if (s != "Y" && s != "y") {
            return false;
        }
    }

    std::cout << "I܂B\n";
    return true;
}
